#include <iostream>
#include <fstream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>

#include "rof.h"
using namespace std;

//setInfomation֐̐錾
void ROF::setInformation(float* lat, float* lon, int x_col, int y_row)
{
	latitude = *lat;
	longitude = *lon;
	if(longitude > 180.0) longitude = longitude - 360.0;

	col = x_col; // setting column number of input datam, 
				 // starting from p0_x. Default is 1.
	row = y_row; // setting row number of input data, 
				 // starting from p0_y. Default is 1.
}

void ROF::initialize()
{
	//0(O̍ŏI)`31̃f[^Zbg
	for(int iday=0; iday<=31; iday++){
		for(int ihour=0; ihour<24; ihour++){
			value[iday][ihour] = 0.0;
		}	
	}
}

void ROF::renewValue(int n_month)
{
	//Ǒ̖̃f[^ value[0][ihour] ɃZbg
	const int dayMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};	

	int c_month;
	c_month = n_month - 1;
	if(c_month == 0){
		c_month = c_month + 12;
	}

	for(int ihour=0; ihour<24; ihour++){
		value[0][ihour] = value[dayMonth[c_month-1]][ihour];
	}
}


void ROF::readValue(int n_year, int n_month)
{
	// read input data file arranged for each data. 


	const int dayMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

	// Ǒ̖̃f[^ value[0][ihour] ɃZbg
	int c_month;
	c_month = n_month - 1;
	if(c_month == 0){
		c_month = c_month + 12;
	}
	for(int ihour=0; ihour<24; ihour++){
		value[0][ihour] = value[dayMonth[c_month-1]][ihour];
	}

	// iday=1`31̃f[^ value[iday][ihour] t@Cǂݎ
	char ROFfilename[256];

	// Use below line when use monthly sorted input data.
	//sprintf_s(ROFfilename, 256, "./input/%04d%02d_%03d_%03d_rain.dat", n_year, n_month, col, row);
	sprintf(ROFfilename, "./input/%04d%02d_%03d_%03d_rain.dat", n_year, n_month, col, row);

	// Use below line when use yearly sorted input data.
	// for Visual C++
	// sprintf_s(ROFfilename, 256, "./input/yearlyData/%04d_%03d_%03d_rain.dat", n_year, col, row);
	// For linux C++
	// sprint(ROFfilename, "./input/yearlyData/%04d_%03d_%03d_rain.dat", n_year, col, row);

	// cout << ROFfilename << endl;

	ifstream fin(ROFfilename);
	if(!fin){
		cout << "ROF file cannot open.\n";
		exit(1);
	}
	//
	//------- Use below 9 lines when use yearly sorted input data.
	// Below lines are used to skip reading until a target month.
        // int totalline = 0;
	// for (int i=0; i < n_month-1; i++) {
	// 	totalline += dayMonth[i];
	// }
	// totalline *= 24;
	// string ss;
	// for (int i=0; i < totalline; i++) {
	// 	getline(fin, ss); // skip reading until a target month.
	// }
	//--------

	int year, month, day, hour;
	float data;
	for(int iday=1; iday<=dayMonth[n_month-1]; iday++){ 
		for(int ihour=0; ihour<24; ihour++){
	        fin >> year >> month >> day >> hour >> data;
			value[iday][ihour] = data;
		}
	}
	fin.close();
}


